/**
 * This file implement a workaround to have the
 * capability to use a kind of convert from deflate
 * to uncompressed.
 * Theorically the nsIStreamConverterService let us do
 * that, but it really seems it don't work for now
 * (throw NS_ERROR_NOt_IMPLEMENTED) on 22/10/2008
 */
var ConverterService = {
  _StreamConverter: Components.Constructor("@mozilla.org/streamconv;1?from=deflate&to=uncompressed","nsIStreamConverter", "asyncConvertData"),
  _InputStreamPump: Components.Constructor("@mozilla.org/network/input-stream-pump;1","nsIInputStreamPump", "init"),
  _BinaryInputStream: Components.Constructor("@mozilla.org/binaryinputstream;1","nsIBinaryInputStream", "setInputStream"),
  from:"deflate",
  to:"uncompressed",
  _lockStack:[],

  _lock:false,
  get lock(){
    return this._lock;
  },

  set lock( aValue ){
    this._lock = false;
    if(this._lockStack.length) {
      let [stream, position, length, pageNumber, callback] = this._lockStack.shift();
      this.convert(stream, position, length, pageNumber, callback);
    }
  }
};

ConverterService.convert = function (aStream, aPosition, aLength, aPageNumber, aCallback) {
  if (this._lock) {
    this._lockStack.push([aStream, aPosition, aLength, aPageNumber, aCallback]);
  }
  else{
    this._lock = true;
    aStream.seek(aStream.NS_SEEK_SET, 0);
    let pump = new this._InputStreamPump(aStream, aPosition, aLength,0,0,false);
    pump.asyncRead(
      new this._StreamConverter(this.from, this.to, new this._deflateListener(aPageNumber,aCallback), null),
      null);
  }
};

ConverterService._deflateListener = function(aPageNumber, aCallback) {
  this._page = aPageNumber;
  this._callBack = aCallback;
  this._data = "";

  this.onStartRequest = function(request, context) {
  };

  this.onDataAvailable = function(aRequest, aContext, anInputStream, anOffset, aCount){
    let binaryInputStream = new ConverterService._BinaryInputStream(anInputStream);
    this._data += binaryInputStream.readBytes(binaryInputStream.available());
  };

  this.onStopRequest = function(request, context, statusCode) {
    if (statusCode) //Something went wrong when decoding
      throw new Error("Error while decoding page " + this._page + "::" + statusCode);
    this._callBack(this._data, this._page);
    ConverterService.lock = false;
  }
};

