/**
 * For now do only a simple xref table.
 *
 * XXX Clean up the code and the tokenizer
 * XXX Solve the \( problem
 * XXX Build a tree of page
 * XXX Create a font table
 * XXX Implement font usage for Type1
 * XXX read embedded image
 * XXX Implement a svg rendering line (or canvas?)
 *
 *
 */


var XREF = function(aStream, anOffset) {
  this.dictionnary = [];
  this.catalogOffset = -1;

  function XREFObject(anOffset,aGeneration, aState) {
    this.offset = anOffset;
    this.generation = aGeneration;
    this.state = aState;
  };
  var tokens = Tokenizer.exec(aStream, anOffset);
  
  for (let i = 0; i < tokens.length; i++) {
    switch (tokens[i]) {
      case "xref":
        //An xref sequence can be composed in many times
        while (tokens[i+1] != "trailer") {
          i+=2;
          let numberOfObject = parseInt(tokens[i],10);
          while (numberOfObject--) {
            var [anOffset, aGeneration, aState] = [tokens[++i], tokens[++i], tokens[++i]];
            anOffset = parseInt(anOffset, 10);
            this.dictionnary.push(new XREFObject(anOffset, aGeneration, aState));
          } 
          //Eat blank line
          while(tokens[i+1] == "")
            i++;
        }
        break;

      case "Root":
        this.catalogOffset = this.dictionnary[parseInt(tokens[++i],10)].offset;
        break;
    }
  }
};



/**
 * @name pdfUtils
 * Some utility function to manipulate the data
 * inside our pdf.
 * Create in an independent object for the start
 * but should be move as private members as soon as 
 * the code seems stable.
 */
var pdfutils = {};


/**
 * @name pdfutils.readPageObject
 * Read a page object and return the 
 * stream position and her length to the
 * caller
 *
 * @param {nsIInputStream} aStream - The stream to get data from
 * @param {int} anOffset - The offset where we have to begin the analysis
 * @return {array} position,length of the data stream
 *
 *
 * XXX Here we probably should do some custom tag system for the
 * stream. This way we can use the Tokenizer and don't break on
 * jpeg for debug purpose...
 */
pdfutils.readPageObject = function(aStream, anOffset) {
  return Tokenizer._execPage(aStream, anOffset);
  
  /*
  var streamSize = 0;
  var inStream = false;
  var tokens = Tokenizer.exec(aStream, anOffset);
  for(let i = 0 ; i<tokens.length ;i++){
    switch(tokens[i]){
      case "stream":
        inStream = true;
      break;
      case "endstream":
        inStream = false;
      break;
    }
    if(inStream){
      streamSize += tokens[i].length;
    }
  }
  */
  /*alert(anOffset + before + "::" + streamSize);
  throw new Error("");*/
  //return [anOffset + before, streamSize];

  /*
  * Another time with the mozilla stream something gone
  * me mad.
  * It seems that readLine work perfectly but it break the
  * tell() of the nsIBinaryInputStream. So we have to monitor 
  * the data by ourselves.
  * XXX We have to use the Tokenizer here!!!
  */
  var haveEat = 0;
  aStream.seek(aStream.NS_SEEK_SET, parseInt(anOffset,10));

  //Jump the first line cause it is the object id
  var headerLine = {};
  aStream.readLine(headerLine);
  haveEat += parseInt(headerLine.value.length,10) + 1; //+1 cause of \n
  
  var enterInStream = false;
  var [position, length] = [ 0, 0];

  var isEnd = false;
  var data = [];

  while (!isEnd) {
    let line = {};
    
    if (enterInStream) {
      //Where are we in the stream now
      position = aStream.tell();
      while (line.value != "endstream") {
        isEnd = !aStream.readLine(line);
      }
      enterInStream = false;
    }
    isEnd = !aStream.readLine(line);

    if (line.value.substr(0,7) == "/Length") {
      var header = line.value.split(" ");
      length = parseInt(header[1], 10);
      haveEat += parseInt(line.value.length) + 1;
    }
    else if (line.value == "stream") {
      enterInStream = true;
      haveEat += parseInt(line.value.length) + 1;
    }
    else if (line.value == "endobj") {
      isEnd = true;
    }
    else{
      //XXX Have to verify that endstream is always followed by endobj
      haveEat += parseInt(line.value.length) + 1;
    }
  }
  alert(parseInt(anOffset,10) + haveEat + "::" + length);
  if (!read)
    throw new Error("" + e);

  return [parseInt(anOffset,10) + haveEat, length];
};

