/**
 * @name jsreader
 * @static
 * Base static class to do the unit test
 */
var jsreader = {};

/**
 * @name jsreader._logFrame
 * @private
 * An internal variable to store a ref to the debug frame
 */
jsreader._logFrame = null;


jsreader.document = null;

let Cc = Components.classes;
let Ci = Components.interfaces;

/**
 * @name jsreader.initialize
 * @static
 * and insane var
 */
jsreader.initialize = function() {
  let file = window.location.search.slice(1);
  /*
  let directoryService = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties);
  let home = (directoryService.get("Home", Ci.nsIFile)).path;

  //this.document = new PDFDocument(home + '/Documents/Code/dailai.pdf');
  //this.document = new PDFDocument(home + '/home/steakdepapillon/Documents/Code/presentation.pdf');
  //this.document = new PDFDocument(home + '/Devel/extensions/js-reader/code/chrome/content/readme.pdf');
  */
  this.document = new PDFDocument(file);
  this._logFrame = document.getElementById("debugFrame");

  /*
  this.test("localizeXREF");
  this.test("buildXREF");
  this.test("pageCountSimple");
  this.test("xref");
  this.test("pageCountLinear");
  */
};

/**
 * @name jsreader.log
 * @static
 * @function
 * @param {string} aPhase - A string representing the test
 * @param {boolean} aResult - Result of the test
 */
jsreader.log = function(someData) {
  var logNode = document.createElement("div");
  logNode.innerHTML = someData;


  this._logFrame.appendChild(logNode);
};


jsreader.dump = function(anArray, aPageNumber) {
  if(document.getElementById("b" + aPageNumber)) {
    var logNode = document.getElementById("b" + aPageNumber);
  }
  else {
    var logNode = document.createElement("div");
    logNode.setAttribute("id", "b" + aPageNumber);
    logNode.style.position = "relative";
  }

  for(var i = 0; i<anArray.length ; i++) {
    let dataNode = document.createElement("div");
    dataNode.style.position = "absolute";
    dataNode.style.left = anArray[i].left + "px";
    dataNode.style.bottom = anArray[i].bottom + "px";

    if(anArray[i].type=="rec") {
      dataNode.style.width = anArray[i].width + "px";
      dataNode.style.height = anArray[i].height + "px";
      dataNode.style.backgroundColor = anArray[i].color;
    }
    else if(anArray[i].type=="line") {
      dataNode.style.width = anArray[i].width + "px";
      dataNode.style.height = 1 + "px";
      dataNode.style.backgroundColor = "black";
    }
    else {
      dataNode.style.fontSize = anArray[i].size + "px";
      dataNode.style.color = anArray[i].color;
      dataNode.innerHTML = anArray[i].data;
    }

    logNode.appendChild(dataNode);
  }

  this._logFrame.appendChild(logNode);
};

